//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//

#define _KVI_DEBUG_CLASS_NAME_ "KviApp"

#include "kvi_app.h"

//============ main ============//

int main( int argc , char **argv)
{
	_debug_entertrace("main");
	QString szAppName=argv[0];
//	debug("Running : %s,%d",argv[0],argc);
	KviApp *lpApp=new KviApp(argc,argv,"kvirc");
	lpApp->startup();
	int retCode=lpApp->exec();
	if(lpApp->m_bRestart){
		KProcess proc;
		proc << szAppName.data();
		proc.start(KProcess::DontCare,KProcess::NoCommunication);
	}
	delete lpApp;
	return retCode;
	_debug_leavetrace("main");
}

//============ KviApp ============//

KviApp::KviApp( int &argc , char **argv , const char *szAppName): KApplication( argc , argv , szAppName )
{
	_debug_entertrace("KviApp");
	m_bRestart=false;
	_debug_leavetrace("KviApp");
}

//============ ~KviApp ============//

KviApp::~KviApp()
{
	_debug_entertrace("~KviApp");
	delete m_lpFrm;
	_debug_leavetrace("~KviApp");
}

//============ startup ============//

void KviApp::startup()
{
	_debug_entertrace("startup");
	m_lpFrm = new KviFrame();
	setMainWidget(m_lpFrm);
	_debug_leavetrace("startup");
}

#include "m_kvi_app.moc"
