//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_CHNG_H_INCLUDED_
#define _KVI_CHNG_H_INCLUDED_

class KviColorChanger : public QWidget{
	Q_OBJECT
public:
	KviColorChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szText,QColor *lpColor);
	~KviColorChanger();
public:
	QColor			*m_lpColor;
	KColorButton	*m_lpColorBtn;
	QLabel			*m_lpLabel;
public slots:
	void applySlot();
};
class KviBoolChanger : public QCheckBox{
	Q_OBJECT
public:
	KviBoolChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szText,bool *lpBool);
	~KviBoolChanger();
public:
	bool			*m_lpBool;
public slots:
	void applySlot();
};
class KviPixmapChanger : public QWidget{
	Q_OBJECT
public:
	KviPixmapChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szText,QString *lpFileName,QPixmap *lpPixmap);
	~KviPixmapChanger();
public:
	QPixmap			*m_lpPixmap;
	QListBox		*m_lpBox;
	QLabel			*m_lpLabel;
	QLabel			*m_lpPreview;
	KIconLoader		*m_lpIL;
	QString			*m_lpFileName;
public slots:
	void applySlot();
	void selectionChanged(int idx);
};

class KviBackgroundChanger : public QGroupBox{
	Q_OBJECT;
public:
	KviBackgroundChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szTitle,QString *pixFileName,QPixmap *lpPixmap,
							QColor *lpColor);
	~KviBackgroundChanger();
public:
	KviPixmapChanger *lpPixChanger;
	KviColorChanger *lpClrChanger;
};


class KviFontChanger : public QWidget{
	Q_OBJECT
public:
	KviFontChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szText,QFont *lpFont);
	~KviFontChanger();
public:
	QFont			*m_lpFont;
	QLabel			*m_lpLabel;
	QPushButton		*m_lpButton;
public slots:
	void applySlot();
	void buttonPressed();
};

class KviCaptionColorChanger : public QGroupBox{
	Q_OBJECT;
public:
	KviCaptionColorChanger(QTabDialog *lpDlg,QWidget *parent,int x,int y,int w,int h,
							const char *szTitle,QString *pixFileName,QPixmap *lpPixmap,
							QColor *lpBkAct,QColor *lpBkInact,QColor *lpFrAct,
							QColor *lpFrInact,QFont *lpFont);
	~KviCaptionColorChanger();
public:
	KviPixmapChanger *lpPixChanger;
	KviColorChanger *lpBkActChanger;
	KviColorChanger *lpBkInactChanger;
	KviColorChanger *lpFrActChanger;
	KviColorChanger *lpFrInactChanger;
	KviFontChanger	*lpFontChanger;
};

#endif //_KVI_CHNG_H_INCLUDED_
