//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_EVEDLG_H_INCLUDED_
#define _KVI_EVEDLG_H_INCLUDED_

class KviEventDialog : public QDialog{
	Q_OBJECT
public:
	KviEventDialog(KviFrame *lpFrame);
	~KviEventDialog();
public:
	KviFrame		*m_lpFrm;
	KviEventManager	*m_lpEventManager;
private:
	KviMultiLineEdit	*m_lpEdit;
	QPushButton		*m_lpDone;
	QComboBox		*m_lpBox;
	QCheckBox		*m_lpCheck;
	QLabel			*m_lpSyntax;
	int m_iLastSelection;
protected:
	virtual void resizeEvent(QResizeEvent *);
	void fillBox();
protected slots:
	void selectionChanged(int idx);
	void activeChanged(bool bOn);
};

#endif //_KVI_EVEDLG_H_INCLUDED_
