//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this program; see the file COPYING.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#include "kvi_app.h"


KviHelp::KviHelp(){};
KviHelp::~KviHelp(){};

helpCmdTable KviHelp::hlpTab[]={
	{ "HELP"         , 4  , &KviHelp::doHelpOnHelp      },{ "INDEX"        , 5  , &KviHelp::doHelpIndex       },
	{ "COMMANDS"     , 8  , &KviHelp::doHelpOnCommands  },{ "DEFINITIONS"  , 11 , &KviHelp::doHelpOnDefs      },
	{ "JOIN"         , 4  , &KviHelp::doHelpOnJoin      },{ "PART"         , 4  , &KviHelp::doHelpOnPart      },
	{ "OP"           , 2  , &KviHelp::doHelpOnOpDeop    },{ "DEOP"         , 4  , &KviHelp::doHelpOnOpDeop    },
	{ "VOICE"        , 5  , &KviHelp::doHelpOnOpDeop    },{ "DEVOICE"      , 7  , &KviHelp::doHelpOnOpDeop    },
	{ "BAN"          , 3  , &KviHelp::doHelpOnOpDeop    },{ "UNBAN"        , 5  , &KviHelp::doHelpOnOpDeop    },
	{ "KICK"         , 4  , &KviHelp::doHelpOnKick      },{ "SET"          , 3  , &KviHelp::doHelpOnSet       },
	{ "UNSET"        , 5  , &KviHelp::doHelpOnUnset     },{ "CTCP"         , 4  , &KviHelp::doHelpOnCtcp      },
	{ "QUERY"        , 5  , &KviHelp::doHelpOnQuery     },{ "CHAT"         , 4  , &KviHelp::doHelpOnChat      },
	{ "IF"           , 2  , &KviHelp::doHelpOnIf        },{ "ECHO"         , 4  , &KviHelp::doHelpOnEcho      },
	{ "RAW"          , 3  , &KviHelp::doHelpOnRaw       },{ "SEND"         , 4  , &KviHelp::doHelpOnSend      },
	{ "WHOIS"        , 5  , &KviHelp::doHelpOnWhois     },{ "KBAN"         , 4  , &KviHelp::doHelpOnKban      },
	{ "MODE"         , 4  , &KviHelp::doHelpOnMode      },{ "WHOWAS"       , 6  , &KviHelp::doHelpOnWhois     },
	{ "USERLIST"     , 8  , &KviHelp::doHelpOnUserlist  },{ "VARIABLES"    , 9  , &KviHelp::doHelpOnVariables },
	{ "$_mynick"     , 8  , &KviHelp::doHelpOnMy        },{ "$_myserver"   , 10 , &KviHelp::doHelpOnMy        },
	{ "$_myip"       , 6  , &KviHelp::doHelpOnMy        },{ "$_myserverip" , 12 , &KviHelp::doHelpOnMy        },
	{ "$_mynetwork"  , 11 , &KviHelp::doHelpOnMy        },{ "$_myrealname" , 12 , &KviHelp::doHelpOnMy        },
	{ "$_myusername" , 12 , &KviHelp::doHelpOnMy        },{ "$_myport"     , 8  , &KviHelp::doHelpOnMy        },
	{ "$_mymask"     , 8  , &KviHelp::doHelpOnMy        },{ "$_chan"       , 6  , &KviHelp::doHelpOnCh        },
	{ "$_window"     , 8  , &KviHelp::doHelpOnCh        },{ "$_status"     , 8  , &KviHelp::doHelpOnCh        },
	{ "$_allchans"   , 10 , &KviHelp::doHelpOnCh        },{ "$_false"      , 7  , &KviHelp::doHelpOnFl        },
	{ "$_true"       , 6  , &KviHelp::doHelpOnFl        },{ "$_null"       , 6  , &KviHelp::doHelpOnFl        },
	{ "CLONESCAN"    , 9  , &KviHelp::doHelpOnClonescan },{ "FUNCTIONS"    , 9  , &KviHelp::doHelpOnIdent     },
	{ "$%chn_opcount" , 13, &KviHelp::doHelpOnChn       },{ "$%chn_voicecount",16,&KviHelp::doHelpOnChn       },
	{ "$%chn_count"   , 11, &KviHelp::doHelpOnChn       },{ "$%chn_nopcount", 14 ,&KviHelp::doHelpOnChn       },
	{ "$%chn_allonchan",15, &KviHelp::doHelpOnChn       },{ "$%chn_oponchan", 14 ,&KviHelp::doHelpOnChn       },
	{ "$%chn_voiceonchan",17,&KviHelp::doHelpOnChn      },{ "$%chn_noponchan",15 ,&KviHelp::doHelpOnChn       },
	{ "$%chn_topic"   , 11, &KviHelp::doHelpOnChn       },{ "$%chn_mode"   , 10 , &KviHelp::doHelpOnChn       },
	{ "$%nck_maskX"  , 11 , &KviHelp::doHelpOnNk        },{ "$%nck_ison"   , 10 , &KviHelp::doHelpOnNk        },
	{ "$%nck_isop"   , 10 , &KviHelp::doHelpOnNk        },{ "$%nck_address", 13 , &KviHelp::doHelpOnNk        },
	{ "$%nck_isvoice", 13 , &KviHelp::doHelpOnNk        },{ "$%box_yesno"  , 11 , &KviHelp::doHelpOnBox       },
	{ "ME"           , 2  , &KviHelp::doHelpOnMe        },{ "$%wnd_ischan" , 12 , &KviHelp::doHelpOnIs        },
	{ "$%nck_isme"   , 10 , &KviHelp::doHelpOnNk        },{ "$_selected"   , 10 , &KviHelp::doHelpOnCh        },
	{ "$_target"     , 8  , &KviHelp::doHelpOnCh        },{ "$_allchats"   , 10 , &KviHelp::doHelpOnCh        },
	{ "$_allqueries" , 12 , &KviHelp::doHelpOnCh        },{ "$_myaddress"  , 11 , &KviHelp::doHelpOnMy        },
	{ "$_allchattargets",16,&KviHelp::doHelpOnCh        },{ "$%str_isin"   , 10 , &KviHelp::doHelpOnStr       },
	{ "$%wnd_ischat" , 12 , &KviHelp::doHelpOnIs        },{ "$%wnd_isstatus",14 , &KviHelp::doHelpOnIs        },
	{ "$%wnd_isquery", 13 , &KviHelp::doHelpOnIs        },{ "$%wnd_issend" , 12 , &KviHelp::doHelpOnIs        },
	{ "TIMER"        , 5  , &KviHelp::doHelpOnTimer     },{ "$%box_input"  , 11 , &KviHelp::doHelpOnBox       },
	{ "EXEC"         , 4  , &KviHelp::doHelpOnProc      },{ "RUN"          , 3  , &KviHelp::doHelpOnProc      },
	{ "KILLPROC"     , 8  , &KviHelp::doHelpOnProc      },{ "WRITEPROC"    , 9  , &KviHelp::doHelpOnProc      },
	{ "PROCLIST"     , 8  , &KviHelp::doHelpOnProc      },{ "WHILE"        , 5  , &KviHelp::doHelpOnIf        },
	{ "PLAY"         , 4  , &KviHelp::doHelpOnPlay      },{ "HALT"         , 4  , &KviHelp::doHelpOnHalt      },
	{ "SAY"          , 3  , &KviHelp::doHelpOnSay       },{ "SERVER"       , 6  , &KviHelp::doHelpOnServer    },
	{ "$%str_length" , 12 , &KviHelp::doHelpOnStr       },{ "$%str_equal"  , 11 , &KviHelp::doHelpOnStr       },
	{ "$%str_nequal" , 12 , &KviHelp::doHelpOnStr       },{ "$%str_lower"  , 11 , &KviHelp::doHelpOnStr       },
	{ "$%str_upper"  , 11 , &KviHelp::doHelpOnStr       },{ "$%str_find"   , 10 , &KviHelp::doHelpOnStr       },
	{ "$%str_left"   , 10 , &KviHelp::doHelpOnStr       },{ "$%str_right"  , 11 , &KviHelp::doHelpOnStr       },
	{ "NOTICE"       , 6  , &KviHelp::doHelpOnNotice    },{ "AWAY"         , 4  , &KviHelp::doHelpOnAway      },
	{ "BACK"         , 4  , &KviHelp::doHelpOnAway      },{ "MSG"          , 3  , &KviHelp::doHelpOnSay       },
	{ "WINDOW"       , 6  , &KviHelp::doHelpOnWindow    },{ "$%wnd_isuserwnd",15, &KviHelp::doHelpOnIs        },
	{ "FOREACH"      , 7  , &KviHelp::doHelpOnForeach   },{ "DNS"          , 3  , &KviHelp::doHelpOnDns       },
	{ "$%lst_append" , 12 , &KviHelp::doHelpOnLst       },{ "$%lst_remove" , 12 , &KviHelp::doHelpOnLst       },
	{ "$%lst_prepend", 13 , &KviHelp::doHelpOnLst       },{ "$%lst_count"  , 11 , &KviHelp::doHelpOnLst       },
	{ "$%lst_item"   , 10 , &KviHelp::doHelpOnLst       },{ "$%lst_find"   , 10 , &KviHelp::doHelpOnLst       },
	{ "$_dirhome"    , 9  , &KviHelp::doHelpOnDir       },{ "$_dirkvirc"   , 10 , &KviHelp::doHelpOnDir       },
	{ "ASCII"        , 5  , &KviHelp::doHelpOnAscii     },{ "$%box_openfile", 14, &KviHelp::doHelpOnBox       },
	{ "$%box_savefile",14 , &KviHelp::doHelpOnBox       },{ "CACHE"        , 5  , &KviHelp::doHelpOnCache     },
	{ 0              , 0  , 0                           }
};

void KviHelp::doHelp(KviMdiChild *lpC,QString &szHlp){
	int nLen=szHlp.length();
	for (int i=0;hlpTab[i].szName!=0;i++){
		if(nLen==hlpTab[i].lenName){
			if (!strncasecmp(szHlp.data(),hlpTab[i].szName,hlpTab[i].lenName)){
		 		(this->*(hlpTab[i].proc))(lpC);
				return;
			}
		}
	}
	//Not found
	doHelpOnHelp(lpC);
}

#define _cmd(__str) lpC->doFmtOutput(KVI_OUT_HELP,"%c%c%s%c%c",KVI_TEXT_REVERSE,KVI_TEXT_UNDERLINE,__str,KVI_TEXT_UNDERLINE,KVI_TEXT_REVERSE);
#define _syn(__str) lpC->doFmtOutput(KVI_OUT_HELP,"  %cSyntax      : %s%c",KVI_TEXT_BOLD,__str,KVI_TEXT_BOLD);
#define _des lpC->doFmtOutput(KVI_OUT_HELP,"  %cDescription :%c",KVI_TEXT_BOLD,KVI_TEXT_BOLD);
#define _hlp(__str) lpC->doFmtOutput(KVI_OUT_HELP,"    %s",__str);
#define _see(__str) lpC->doFmtOutput(KVI_OUT_HELP,"  %cSee also    : %s%c",KVI_TEXT_BOLD,__str,KVI_TEXT_BOLD);
#define _exa(__str) lpC->doFmtOutput(KVI_OUT_HELP,"  %cExample     :%c %s",KVI_TEXT_BOLD,KVI_TEXT_BOLD,__str);

//============ doHelpOnHelp ============//

void KviHelp::doHelpOnHelp(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnHelp");
	_cmd("HELP");
	_syn("HELP <argument>");
	_des;
	_hlp("Provides help for user commands.");
	_hlp("See /help index for a list of arguments.");
	_hlp("In later version this help will be substituted by the");
	_hlp("html version,and will be reduced to contain syntax only.");
	_see("INDEX"); 
	_debug_leavetrace("doHelpOnHelp");
}

//============ doHelpOnServer ============//

void KviHelp::doHelpOnServer(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnServer");
	_cmd("SERVER");
	_syn("SERVER <server-name> [port]");
	_des;
	_hlp("Attempts connection to a server.");
	_hlp("If there is already another connection,KVIrc disconnects first.");
	_hlp("KVIrc looks for the <server-name> in the list of available servers.");
	_hlp("If an entry is found,that entry is brought to top of the list.");
	_hlp("If a port is specified,the port replaces the default entry port.");
	_hlp("If there is no entry with that name,a new entry is created on top");
	_hlp("of the list. KVIrc then attempts connecting to the first server in");
	_hlp("in the list (just like pressing the 'Connect' button).");
	_debug_leavetrace("doHelpOnServer");
}
//============ doHelpOnCache ============//
void KviHelp::doHelpOnCache(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnCache");
	_cmd("CACHE");
	_syn("CACHE (load|store|clear|remove|flush) [section] [key] [ <string-value> | <variable> ]");
	_des;
	_hlp("The caceh command is used to save string data bewtween kvirc sessions.");
	_hlp("The data is stored on disk in the $HOME/kvirc/Config/kvi.cache.conf file.");
	_hlp("The data is oragnized in sections and localized by keys.");
	_hlp("CACHE load <section> <key> <variable>");
	_hlp("   This will load the string referenced by <key> in the <section> to the <variable>.");
	_hlp("   If the key or section can not be found the variable is set to $_null");
	_exa("CACHE load auto.op.lists chan.kaos.list $op.list");
	_hlp("CACHE store <section> <key> <string-value>");
	_hlp("   This will store the data in the cache sunder the specified <key> and <section>"); 
	_exa("CACHE store RevengeSection LastNickThatBannedMe $last.me.banner");
	_hlp("CACHE clear");
	_hlp("   This will crear the cache in memory.");
	_hlp("CACHE remove <section> [key]");
	_hlp("   This will remove a specified key in a section , or the entire section if the key");
	_hlp("   is not provided.");
	_hlp("CACHE flush");
	_hlp("   This will store the cache on disk.The cache is automatically flushed when");
	_hlp("   kvirc terminates.");
	_see("SET UNSET");
	_debug_leavetrace("doHelpOnCache");
}
//============ doHelpOnAscii ============//
void KviHelp::doHelpOnAscii(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnAscii");
	_cmd("ASCII");
	_syn("ASCII  [ [-stop] | [filename [ window [timeout]]] ]");
	_des;
	_hlp("The ascii command is used to 'play' ascii files to a channel,query or chat,");
	_hlp("Useful to displaying images or reading files.");
	_hlp("Parameters:");
	_hlp("-stop    : This will stop all the currently playing files.");
	_hlp("filename : Filename to play.If the filename contains a '/' it is");
	_hlp("           assumed to be an absolute path , otherwise kvirc looks");
	_hlp("           for the file in the $HOME/kvirc/Ascii and $HOME/kvirc/Scripts/Ascii");
	_hlp("           directories.");
	_hlp("window   : The target window to play the file.If not specified,");
	_hlp("           the current window is assumed to be the target.");
	_hlp("           KVirc behaviour depends on the type of the target window.");
	_hlp("           In a channel,query or DCC chat window,the text is sent to ");
	_hlp("           the relative target,just like typing each line of text");
	_hlp("           in the input box...that means that the identifiers are parsed.");
	_hlp("           In this way , you can NOT begin a line with '/' in your picture file");
	_hlp("           since it will be interpreted as a command.");
	_hlp("           In all other windows the file is 'echoed' only.");
	_hlp("timeout  : Time to wait between sending lines (default 1 sec) in millisec.");
	_exa("/ASCII beer.txt $_chan 2000");
	_debug_leavetrace("doHelpOnAscii");
}
//============ doHelpOnWindow ============//
void KviHelp::doHelpOnWindow(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnWindow");
	_cmd("WINDOW");
	_syn("WINDOW <operation> <[*]window-name> [open-parameters] [image-file]");
	_syn("<operation> ::= (hide|show|open|close|maximize|restore|setimage)");
	_des;
	_hlp("Creates , closes , (un)hides ...an user window.");
	_hlp("For the close and open operations the window-name MUST begin with a '*'");
	_hlp("The [open-paramaters] are valid for the 'open' operation.");
	_hlp("<open-parameters> :");
	_hlp("  noinput             = Creates a window without the input box");
	_hlp("  noclose             = Creates a window with the close button disabled");
	_hlp("  hidden              = Creates a hidden window");
	_hlp("  size=x,y,w,h        = Creates a window with the specified width,height and position");
	_hlp("                        the x,y,w,h parameters must be specified in pixels");
	_hlp("                        referring to the view of the main kvirc window.");
	_hlp("  timestamp=(true|false) = overrides the default timestamp setting.");
	_hlp("  images=(true|false) = overrides the default 'show-mssage-images' setting.");
	_hlp("  background=filename = Creates a window with the specified background image");
	_hlp("                        The filename param can be either a full path to a file");
	_hlp("                        or a simple file name.");
	_hlp("                        If a file name is specified, then kvirc searches for that file in");
	_hlp("                        $HOME/kvirc/Images and in $KDEDIR/share/apps/kvirc");
	_hlp("                        If the file can not be found , the default background is used.");
	_hlp(" font=fontname[,size] = Creates a window with a specified font.");
	_hlp("If the 'noinput' is not provided, the window will have an input box.");
	_hlp("You will be able to type commands in.");
	_hlp("All the text typed that doesn't form a command , will be passed to the");
	_hlp("Event_OnUserWndInput event (if enabled).");
	_hlp("The 'setimage' operation , sets the <image-file> as bacground for that window.");
	_hlp("The [image-file] name follow the same rules as for 'open' background=");
	_exa("/WINDOW open @test noclose noinput size=10,10,200,300");
	_debug_leavetrace("doHelpOnWindow");
}
//============ doHelpOnSay ============//
void KviHelp::doHelpOnSay(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnSay");
	_cmd("SAY MSG");
	_syn("SAY <window/target> <text>");
	_des;
	_hlp("Sends text to the specified window/target.");
	_hlp("If the <window/target> parameter is a window name");
	_hlp("(eg. a channel,query or chat window with that name exists),");
	_hlp("the effect of this command is the same");
	_hlp("as typing <text> in that window.");
	_exa("/SAY $_status PRIVMSG #kaos : Byez");
	_exa("/SAY $_chan /RAW PRIVMSG #kaos : Byez");
	_hlp("The examples above will send the same raw data to the server.");
	_hlp("If the window can not be found (or it is NOT a channel,query or chat)");
	_hlp("The <text> will be sent to the server as");
	_hlp("MSG is an alias for this command");
	_hlp("PRIVMSG <window/target> :<text>.");
	_debug_leavetrace("doHelpOnSay");
}
//============ doHelpOnAway ============//
void KviHelp::doHelpOnAway(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnAway");
	_cmd("AWAY BACK");
	_syn("AWAY [away-message]");
	_des;
	_hlp("Sets the away state.If no away-message is provided, the default one is used.");
	_syn("BACK");
	_des;
	_hlp("Removes the away state");
	_debug_leavetrace("doHelpOnAway");
}
//============ doHelpOnNotice ============//
void KviHelp::doHelpOnNotice(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnNotice");
	_cmd("NOTICE");
	_syn("NOTICE <target-list> <text>");
	_des;
	_hlp("Sends the text to the specified targets in the NOTICE format.");
	_exa("/NOTICE Pragma You are added to my oplist now.");
	_exa("/NOTICE #kaos,Pragma,Drosha Please stop nuking me!"); 
	_see("SAY ME");
	_debug_leavetrace("doHelpOnNotice");
}
//============ doHelpOnHalt ============//
void KviHelp::doHelpOnHalt(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnHalt");
	_cmd("HALT");
	_syn("HALT");
	_des;
	_hlp("Stops the execution of a command (event or alias).");
	_debug_leavetrace("doHelpOnHalt");
}
//============ doHelpIndex ============//
void KviHelp::doHelpIndex(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpIndex");
	_cmd("INDEX");
	_hlp("This is a subset of topics available using the /HELP command");
	_hlp("----------------- General informations-------------------");
	_hlp("INDEX       COMMANDS    DEFINITIONS VARIABLES   FUNCTIONS");
	_hlp("------------------------Commands-------------------------");
	_hlp("JOIN        PART        OP          DEOP        VOICE");
	_hlp("DEVOICE     BAN         UNBAN       KICK        SET");
	_hlp("UNSET       CTCP        CHAT        QUERY       IF");
	_hlp("WHILE       RAW         SEND        WHOIS       MODE");
	_hlp("USERLIST    CLONESCAN   ME          TIMER       EXEC");
	_hlp("RUN         KILLPROC    WRITEPROC   PROCLIST    ECHO");
	_hlp("PLAY        HALT        SAY         SERVER      NOTICE");
	_hlp("KBAN        WHOWAS      MSG         WINDOW      FOREACH");
	_hlp("DNS         ASCII       CACHE       MSG         AWAY");
	_hlp("BACK");
	_debug_leavetrace("doHelpIndex");
}
//============ doHelpOnDns ============//
void KviHelp::doHelpOnDns(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnDns");
	_cmd("DNS");
	_syn("DNS ( <hostname> | <ip> )");
	_des;
	_hlp("Performs a DNS query for the specified host or ip address.");
	_hlp("KVirc uses an external program (kvidns) to make the query.");
	_debug_leavetrace("doHelpOnDns");
}
//============ doHelpOnProc ============//
void KviHelp::doHelpOnProc(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnProc");
	_cmd("EXEC RUN KILLPROC WRITEPROC PROCLIST");
	_syn("EXEC      <commandline>");
	_syn("RUN       <commandline>");
	_syn("KILLPROC  ( all | <process-pid> )");
	_syn("WRITEPROC <process-pid>");
	_syn("PROCLIST");
	_des;
	_hlp("These functions will start|stop|or communicate with child processes.");
	_hlp("RUN       : Starts an EXTERNAL process. Once started the process lives its own life.");
	_exa("/RUN kedit README.txt");
	_hlp("EXEC      : Starts a CHILD process. The process runs 'with' KVIrc,");
	_hlp("            and it will be terminated when KVIrc exits.");
	_hlp("            If the process outputs something to stdout or stderr, you will");
	_hlp("            see it like in a shell.");
	_hlp("            It's also possible to write to stdin of this process.");
	_exa("/EXEC /bin/bash");
	_hlp("KILLPROC  : Kills a proces with a specified process id,");
	_hlp("            or all processes if 'all' is specified instead of a pid.");
	_hlp("WRITEPROC : Writes to a process with the specified pid.");
	_hlp("            A <LF> character is appended to the input buffer.");
	_hlp("PROCLIST  : Lists all running child processes.");
	_hlp("Here is a short example of use of all these functions:");
	_exa("/EXEC telnet localhost");
	_exa("# Starting process 'telnet localhost' with pid 7999");
	_exa("# [stdout 7999] : Trying 127.0.0.1...");
	_exa("# [stdout 7999] : Connected to localhost,escape character is....");
	_exa("# [stdout 7999] : Login :");
	_exa("/WRITEPROC 7999 root");
	_exa("# [stdin  7999] : root");
	_exa("# [stdout 7999] : Password :");
	_exa("/WRITEPROC 7999 mypassword");
	_exa("# [stdin  7999] : mypassword");
	_exa("# [stdout 7999] : Last login on tty4 on 12.4.2007 ...");
	_exa("# [stdout 7999] : [root@localhost root]");
	_exa("/PROCLIST");
	_exa("# Pid :7999 Commandline :telnet localhost");
	_exa("/KILLPROC 7999");
	_exa("# Process 7999 Killed.");
	_debug_leavetrace("doHelpOnProc");
}
//============ doHelpOnTimer ============//
void KviHelp::doHelpOnTimer(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnTimer");
	_cmd("TIMER");
	_syn("TIMER (start|stop|kill|list|shot) [name] [timeout] [command]");
	_des;
	_hlp("This command manages internal timers.");
	_hlp("START:");
	_hlp("  Syntax: TIMER start <timer-name> <timeout-in-msec> <command>");
	_hlp("  The start option will start an internal timer.");
	_hlp("  If a timer with the same name is already running it will be replaced.");
	_hlp("  The timeout must be specified in milliseconds , and the lower");
	_hlp("  limit for that parameter is 100 msec.");
	_hlp("  Please note that many timers (or 2-3 timers with a short timeout)");
	_hlp("  may slow down kvirc,especially if the command executed outputs");
	_hlp("  text using the echo command.");
	_hlp("  The command parameter specifies the command to be executed when");
	_hlp("  the timer 'fires'.");
	_exa("  TIMER start test_timer 10000 /echo $_window Timeout!!!");
	_hlp("  In this example the command will be created a timer with name");
	_hlp("  test_timer and 10 seconds timeout.");
	_hlp("  NOTE : The identifiers in the command are parsed when the timer is created!");
	_hlp("  The timer is 'connected' to the window where it is started.");
	_hlp("  If you start a timer in the #channel window (or start it in a command");
	_hlp("  that is running 'in that window',each call to $_window or $_chan will");
	_hlp("  return #channel.");
	_hlp("  If the window can not be found when the timer 'fires',");
	_hlp("  the timer is automatically removed.");
	_hlp("SHOT:")
	_hlp("  Syntax: TIMER shot <timeout> <command>");
	_hlp("  This will create a timer that fires only once with the specified timeout.");
	_hlp("  Useful for example to perform temporaneous bans from popups : ");
	_hlp("  Popup command:");
	_hlp("  kban $_selected 10 seconds ban!; timer shot 10000 /unban $_selected");
	_hlp("STOP:");
	_hlp("  Syntax: TIMER stop <timer-name>");
	_hlp("  The stop option will remove an internal timer.");
	_hlp("  If the timer is not running,it will do nothing.");
	_exa("  TIMER stop test_timer");
	_hlp("LIST:");
	_hlp("  Syntax: TIMER list");
	_hlp("  This will print a list of currently active timers.");
	_hlp("KILL:");
	_hlp("  Syntax: TIMER kill");
	_hlp("  This will stop ALL the active timers.");
	_debug_leavetrace("doHelpOnTimer");
}
//============ doHelpOnMe ============//
void KviHelp::doHelpOnMe(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnMe");
	_cmd("ME");
	_syn("ME <text>");
	_des;
	_hlp("This command is used to describe an action/feeling to the channel.");
	_hlp("It can be used in channel , query or DCC Chat windows.");
	_hlp("Equivalent to /CTCP ACTION #channel <text>.");
	_see("CTCP"); 
	_debug_leavetrace("doHelpOnMe");
}
//============ doHelpOnCommands ============//
void KviHelp::doHelpOnCommands(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnCommands");
	_cmd("COMMANDS");
	_hlp("KVirc treates as a <command> any sequence of characters that you type in");
	_hlp("the commandline box of a <child> window, and that starts with a '/'");
	_hlp("Everything else is treated in the following way:");
	_hlp("- All the <non-commands> typed in the status cosole window are sent to");
	_hlp("  the current server,exactly as they are...(In RAW format)");
	_hlp("- All the <non-commands> typed in a channel window are sent to");
	_hlp("  the server as 'privmsg #channel <non-command>' (talk to channel)");
	_hlp("- All the <non-commands> typed in a query window are sent to");
	_hlp("  the server as 'privmsg <query-nickname>' (talk to the query)");
	_hlp("- All the <non-commands> typed in a chat window are sent through");
	_hlp("  the corresponding DCC connection (if any)");
	_hlp("- All the <non-commands> typed in a user created window are handled by");
	_hlp("  the Event_OnUserWndInput event.");
	_hlp("General command syntax:");
	_hlp("KVirc uses an extended commandline syntax, that allows you to execute");
	_hlp("more commands in sequence (pipe).");
	_hlp("- A sequence of commands MUST start with a '/' (as described above)");
	_hlp("- The commands are separated by a ';'");
	_hlp("- The last command may not contain the trailing ';'");
	_hlp("- The commands are NOT case sensitive");
	_hlp("Here are some examples of simple valid commandlines:");
	_exa("/JOIN #channel");
	_exa("/JOIN #channel;");
	_exa("/jOiN #channel;PART #channel");
	_exa("/join #channel,#channel2,#channel3;SAY #channel2 What's on?;PART #channel3");
	_hlp("- The commands can be grouped by block separators ('<' and '>'),");
	_hlp("  and the closing block separator must be followed by a ';',");
	_hlp("  as a normal command.");
	_exa("/JOIN #channel;< Part #channel; >");
	_exa("/< join &errors;PART &servers; >;JOIN &debug");
	_see("DEFINITIONS");
	_debug_leavetrace("doHelpOnCommands");
}
//============ doHelpOnDefs ============//
void KviHelp::doHelpOnDefs(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnDefs");
	_cmd("DEFINITIONS");
	_hlp("This topic describes some parts of the grammar used by KVirc");
	_hlp("You will find it useful when reading syntax of commands.");
	_hlp("---General rules---");
	_hlp("The grammar productions are described using the following syntax:");
	_hlp("<left-part>    ::= 'right-part' | 'alternative' | ...");
	_hlp("the one above means that the non-terminal symbol <left-part>");
	_hlp("is replaced  by 'right-part' (that can be terminal or not...)");
	_hlp("or by the 'alternative'.");
	_hlp("<left-part>    ::= c[ x ] | d( a | b )");
	_hlp("the one above means that <left-part> can be replaced by");
	_hlp("'c' that CAN be followed by a 'x' ,");
	_hlp("or by a 'd' that MUST be followed by a 'a' or a 'b'.");
	_hlp("--------------------");
	_hlp("<string>        ::= any non empty sequence of characters without spaces");
	_hlp("<channel>       ::= ( # | & )<string>");
	_hlp("<nick>          ::= <string>");
	_hlp("<channel-list>  ::= <channel>[,<channel-list>]");
	_hlp("<nick-list>     ::= <nick>[,<nick>]");
	_hlp("<variable>      ::= $<string>");
	_hlp("<sys-variable>  ::= $_<string>");
	_hlp("<sys_identifier>::= $%<prefix>_<string>");
	_debug_leavetrace("doHelpOnDefs");
}
//============ doHelpOnJoin ============//
void KviHelp::doHelpOnJoin(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnJoin");
	_cmd("JOIN");
	_syn("JOIN <channel-list>");
	_des;
	_hlp("Joins channel(s).");
	_exa("JOIN #kaos,#linux,#kvirc");
	_see("PART");
	_debug_leavetrace("doHelpOnJoin");
}
//============ doHelpOnPlay ============//
void KviHelp::doHelpOnPlay(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnPlay");
	_cmd("PLAY");
	_syn("PLAY [file-name]");
	_des;
	_hlp("This command plays a sound file.");
	_hlp("If <file-name> is specified,");
	_hlp("if it contains a '/' it is assumed to be");
	_hlp("an absolute path , else KVIrc will look for that file");
	_hlp("in the $HOME/kvirc/Audio directory and after in $HOME/kvirc/Scripts/Audio.");
	_debug_leavetrace("doHelpOnPlay");
}
//============ doHelpOnPart ============//
void KviHelp::doHelpOnPart(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnPart");
	_cmd("PART");
	_syn("PART <channel-list> <part-message-text>");
	_des;
	_hlp("Leaves channel(s) sending the specified part message.");
	_hlp("If no message is specified, the default message is used.");
	_exa("PART #kaos,#linux,#kvirc Byez people!");
	_exa("PART $_allchans $_version");
	_see("JOIN");
	_debug_leavetrace("doHelpOnPart");
}
//============ doHelpOnOpDeop ============//
void KviHelp::doHelpOnOpDeop(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnOpDeop");
	_cmd("OP DEOP VOICE DEVOICE BAN UNBAN");
	_syn("OP    [channel] <nick-list>     DEOP    [channel] <nick-list>");
	_syn("VOICE [channel] <nick-list>     DEVOICE [channel] <nick-list>");
	_syn("BAN   [channel] <mask-list>     UNBAN   [channel] <mask-list>");
	_des;
	_hlp("Changes mode on a specified channel.");
	_hlp("Op sets mode +o for each nick in the nick list");
	_hlp("Deop sets mode -o,voice and devoice : +v and -v");
	_hlp("Ban and unban sets modes +b and -b for each mask in the mask-list");
	_hlp("The channel parameter is optional when the command is executed in");
	_hlp("a channel window.");
	_hlp("These six commands are optimized for speed and efficience:");
	_hlp("when more than one nicks (or masks) are provided,KVIrc will use");
	_hlp("the extended MODE command syntax, using multiple mode changes in");
	_hlp("one message to server.(up to three)");
	_exa("OP #kaos Pragma,Ventur,Mixo   <---Ops three nicks : One message to server");
	_exa("BAN Ventur!*@*,turk187!*@*,Mixo!*@*,Diabl0!*@* <---Bans 4 masks on the current");
	_exa("                                                   channel. Two messages");
	_debug_leavetrace("doHelpOnOpDeop");
}
//============ doHelpOnKick ============//
void KviHelp::doHelpOnKick(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnKick");
	_cmd("KICK");
	_syn("KICK [channel] <nick-list> [kick-reason]");
	_des;
	_hlp("Kicks user(s) from a channel using the specified reason.");
	_hlp("If no reason is specified, the default one is used.");
	_hlp("The channel parameter is optional when executed from a channel window.");
	_exa("KICK $_chan Ventur,Diabl0 Go sit in a corner...");
	_debug_leavetrace("doHelpOnKick");
}
//============ doHelpOnSet ============//
void KviHelp::doHelpOnSet(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnSet");
	_cmd("SET");
	_syn("SET <variable> <value>");
	_des;
	_hlp("Sets a variable value. Note that the <value> is treated as a string.");
	_see("DEFINITIONS UNSET");
	_debug_leavetrace("doHelpOnSet");
}
//============ doHelpOnUnset ============//
void KviHelp::doHelpOnUnset(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnUnset");
	_cmd("UNSET");
	_syn("UNSET <variable>");
	_des;
	_hlp("Unsets a variable.If the variable was not set,this command does nothing.");
	_see("DEFINITIONS SET");
	_debug_leavetrace("doHelpOnUnset");
}
//============ doHelpOnCtcp ============//
void KviHelp::doHelpOnCtcp(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnCtcp");
	_cmd("CTCP");
	_syn("CTCP <type> <target-list> [ctcp-arguments]");
	_des;
	_hlp("Sends a specified CTCP type to the specified user(s).");
	_hlp("CTCP Types:");
	_hlp("PING       : pings a user in order to have his response time.");
	_hlp("VERSION    : requests user's client version.");
	_hlp("TIME       : requests user's local time.");
	_hlp("CLIENTINFO : requests user's client informations.");
	_hlp("USERIFON   : requests user's informations.");
	_hlp("FINGER     : requests user's finger.");
	_hlp("ACTION     : describes an action.");
	_hlp("SOURCE     : requests informationf on where to find the user's client.");
	_hlp("These are the known CTCP types , but if you want you can");
	_hlp("use any CTCP type name.");
	_hlp("CTCP CIAO Nick is a valid CTCP, but maybe you will receive no response :)");
	_hlp("A target may be a either a nick or a channel.");
	_hlp("The ctcp arguments are intended for the extended ctcp's...");
	_hlp("You can send a '/ctcp cdcc list' to someone by typing:");
	_exa("/ctcp cdcc target_nickname list");
	_see("CHAT SEND");
	_debug_leavetrace("doHelpOnCtcp");
}
//============ doHelpOnQuery ============//
void KviHelp::doHelpOnQuery(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnQuery");
	_cmd("QUERY");
	_syn("QUERY <nick-list>");
	_des;
	_hlp("Opens a query window for the specified user(s).");
	_see("CHAT");
	_debug_leavetrace("doHelpOnQuery");
}
//============ doHelpOnChat ============//
void KviHelp::doHelpOnChat(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnChat");
	_cmd("CHAT");
	_syn("CHAT <nick-list>");
	_des;
	_hlp("Requests a DCC CHAT from the specified user(s).");
	_see("QUERY SEND");
	_debug_leavetrace("doHelpOnChat");
}
//============ doHelpOnIf ============//
void KviHelp::doHelpOnIf(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnIf");
	_cmd("IF WHILE");
	_syn("IF    (<boolean-expression>) <command1>; [else <command2> ;]");
	_syn("WHILE (<boolean-expression>) <command>");
	_des;
	_hlp("IF :Conditional expression.");
	_hlp("If <boolean-expression> evaluates to 'true' (see below) the <command1>");
	_hlp("is executed , otherwise (if given) command2 is executed.");
	_hlp("The <boolean-expression> is assumed to be 'false' if the result");
	_hlp("of 'calculations' in that expression is 0 , $_false or $_null.");
	_hlp("Every other result evaluates to 'true'.");
	_exa("if ( $_true ) echo $_window Evaluates to true.");
	_exa("if ( $_null ) echo $_window Never executed ; else echo $_window Evaluates to false.");
	_exa("if ( test   ) echo $_window Evaluates to true.");
	_hlp("The boolean expression can contain boolean operators: ! , & , |");
	_hlp("! = LOGICAL UNARY NOT    & = LOGICAL BINARY AND  | = LOGICAL BINARY OR");
	_exa("if ( !$_null ) echo $_window Evaluates to true.");
	_exa("if ( $_true | $_false ) echo $_window Evaluates to true.");
	_exa("if ( !$_false & $_true ) echo $_window Evaluates to true.");
	_hlp("Complex boolean expressions MUST be enclosed in parenthesis.");
	_exa("if ( ( $_false | true ) & !$_false) echo $_windwo Evaluates to true."); 
	_hlp("NOTE That there MUST be a <SPACE> between the if command and the parenthesis.");
	_hlp("WHILE :Conditional iteration.");
	_hlp("While <boolean-expression> evaluates to true the <command> is executed.");
	_hlp("Apply the same rules as the if command.");
	_exa("/WHILE ($%box_yesno[Continue?]) echo $_window Continuing...;"); 
	_debug_leavetrace("doHelpOnIf");
}
//============ doHelpOnForeach ============//
void KviHelp::doHelpOnForeach(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnForeach");
	_cmd("FOREACH");
	_syn("FOREACH (<variable>,<string-list>) <command>");
	_des;
	_hlp("Foreach si a loop similar to while , but has no conditional expression.");
	_hlp("It is used to perform repeated commands on a list of arguments.");
	_exa("/FOREACH ($name,John,Ronnie,Marta,Sammy) echo $_window $name is hungry");
	_hlp("The above example will repeat the 'echo' command 4 times,");
	_hlp("one time 'for each' name in the list.");
	_hlp("The <string-list> can be also a variable.");
	_hlp("You will find it useful when writing aliases and popups.");
	_hlp("In a popup you can have multiple selections that are returned");
	_hlp("by $_selected in a from of a comma-separated list.");
	_exa("...In a popup handler : Mass Bye");
	_exa("/foreach ($nickname,$_selected) say $_nickname Bye!,I'm going sleep");
	_hlp("This will say 'Bye!,I'm going sleep' to each nickname selected in the nick list.");
	_hlp("$nickname in this case is a VARIABLE that is set when the command begins,");
	_hlp("updated each time the loop is repeated and unset when the command finishes.");
	_hlp("WARNING : The variables are always unique to kvirc, that means that is");
	_hlp("you call a function in <command> that uses a variable with a similar name");
	_hlp("and changes its contents or unsets it,the remaining part of the <command>");
	_hlp("Will see the changed variable!");
	_hlp("This may be dangerous , when using recursive functions. Be careful with that.");
	_see("SET UNSET");
	_debug_leavetrace("doHelpOnForeach");
}
//============ doHelpOnEcho ============//
void KviHelp::doHelpOnEcho(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnEcho");
	_cmd("ECHO");
	_syn("ECHO <window-name> <text>");
	_des;
	_hlp("Outputs th <text> to the specified window.");
	_debug_leavetrace("doHelpOnEcho");
}
//============ doHelpOnRaw ============//
void KviHelp::doHelpOnRaw(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnRaw");
	_cmd("RAW");
	_syn("RAW <command>");
	_des;
	_hlp("Sends a raw command to the server.");
	_hlp("You may use if to perform commands that are not implemented yet in kvirc");
	_exa("RAW KILL Gregor :Stop flooding!");
	_debug_leavetrace("doHelpOnRaw");
}
//============ doHelpOnSend ============//
void KviHelp::doHelpOnSend(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnSend");
	_cmd("SEND");
	_syn("SEND <nick-list> [file-name]");
	_des;
	_hlp("Requests a DCC SEND to the specified user(s).");
	_hlp("If the file name is not provided, a file dialog will popup.");
	_see("CHAT");
	_debug_leavetrace("doHelpOnSend");
}
//============ doHelpOnWhois ============//
void KviHelp::doHelpOnWhois(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnWhois");
	_cmd("WHOIS WHOWAS");
	_syn("WHOIS [[server]|[-i]] <nick-list>");
	_syn("WHOWAS <nick-list> [ count [server] ]");
	_des;
	_hlp("Requests informations on the specified user(s).");
	_hlp("If the server parameter is provided, the request is");
	_hlp("redirected to that server.(Useful to know the idle time)");
	_hlp("If you don't know the server that nick is connected to");
	_hlp("You can pass the -i flag that will be substituted");
	_hlp("by the server that is used by the first nick in the <nick-list>");
	_hlp("In the whowas command the count param describes the number of");
	_hlp("matching records that the server may return.");
	_exa("WHOIS irc.stealth.net Gizmo");
	_exa("WHOWAS Gizmo 3 irc.stealth.net");
	_debug_leavetrace("doHelpOnWhois");
}
//============ doHelpOnKban ============//
void KviHelp::doHelpOnKban(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnKban");
	_cmd("KBAN");
	_syn("KBAN [channel] <nick-list> [kick-reason]");
	_des;
	_hlp("Kicks and bans the specified user(s) from a channel.");
	_hlp("This command is provided for convenience (just to be fast...");
	_hlp("The channel parameters is optional when executed from a channel window.");
	_hlp("KVIrc uses no ban-mask in this case:the commands sent");
	_hlp("to server for each nick are:");
	_hlp("  KICK <channel> <nick> <reason>");
	_hlp("  MODE <channel> +b <nick>");
	_hlp("On most irc server this results in a nick!*@* ban.");
	_hlp("If no reason is provided , the default one is used.");
	_see("KICK MODE BAN");
	_debug_leavetrace("doHelpOnKban");
}
//============ doHelpOnMode ============//
void KviHelp::doHelpOnMode(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnMode");
	_cmd("MODE");
	_syn("MODE ( <channel>|<nick> ) <mode> [mode-params]");
	_des;
	_hlp("This is just the RFC1459 mode command implementation.");
	_see("OP VOICE BAN");
	_debug_leavetrace("doHelpOnMode");
}
//============ doHelpOnUserlist ============//
void KviHelp::doHelpOnUserlist(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnUserlist");
	_cmd("USERLIST");
	_syn("USERLIST [channel] [nick-list]");
	_des;
	_hlp("Shows internal channel user list entries for the specified user(s).");
	_hlp("The channel parameter is optional when executed from a channel window.");
	_hlp("If no nick-list is provided,the entire userlist is shown."); 
	_debug_leavetrace("doHelpOnUserlist");
}
//============ doHelpOnClonscan ============//
void KviHelp::doHelpOnClonescan(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnClonescan");
	_cmd("CLONESCAN");
	_syn("CLONESCAN [channel] [nick-list]");
	_des;
	_hlp("Searches for clones of the specified user(s) on a channel.");
	_hlp("The channel parameter is optional when executed from a channel window.");
	_hlp("If no nick-list is provided,a global clonescan is done."); 
	_hlp("Note that CLONE means : a user with the same host address.");
	_debug_leavetrace("doHelpOnClonescan");
}
//============ doHelpOnIdent ============//
void KviHelp::doHelpOnIdent(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnIdent");
	_cmd("FUNCTIONS");
	_hlp("The fuctions are a kind of <internal-identifiers>.");
	_hlp("A function is always prefixed with '$%'");
	_hlp("and has the first three letters identyfying a function group");
	_hlp("<function> ::= $%<name>'['<parameter list>']");
	_hlp("INTERNAL FUNCTIONS LIST");
	_hlp("$%chn_allonchan $%chn_oponchan   $%chn_voiceonchan $%chn_noponchan");
	_hlp("$%chn_count     $%chn_opcount    $%chn_nopcount    $%chn_voicecount");
	_hlp("$%chn_topic     $%chn_mode       $%nck_maskX       $%nck_ison");
	_hlp("$%nck_isop      $%nck_address    $%nck_isvoice     $%box_yesno");
	_hlp("$%wnd_ischan    $%wnd_ischat     $%wnd_isquery     $%wnd_isstatus");
	_hlp("$%wnd_issend    $%wnd_isuserwnd  $%nck_isme        $%str_equal");
	_hlp("$%str_nequal    $%str_length     $%str_upper       $%str_lower");
	_hlp("$%str_isin      $%str_find       $%str_left        $%str_right");
	_hlp("$%box_input     $%lst_prepend    $%lst_append      $%lst_count");
	_hlp("$%lst_remove    $%lst_item       $%lst_find        $%bpx_openfile");
	_hlp("$%box_savefile");
	_see("VARIABLES IF ECHO");
	_debug_leavetrace("doHelpOnIdent");
}
//============ doHelpOnLst ============//
void KviHelp::doHelpOnLst(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnLst");
	_cmd("$%lst_* FAMILY FUNCTIONS");
	_hlp("The $%lst_* functions perform operation on comma separated lists");
	_des;
	_syn("$%lst_count[<string-list>]");
	_hlp("  Returns the number of items in the list.");
	_hlp("  There are not items when the string is equal to $_null");
	_syn("$%lst_prepend[<string>,<string-list>]");
	_hlp("  Inserts the <string> as the first item of the list.");
	_syn("$%lst_append[<string>,<string-list>]");
	_hlp("  Inserts the <string> as the last item of the list.");
	_syn("$%lst_remove[<string-item>,<string-list>]");
	_hlp("  Removes the first occurence of <string-item> in the list.");
	_syn("$%lst_item[<index>,<string-list>]");
	_hlp("  Returns the item in the string-list at position <index>");
	_hlp("  or $_null if the index is out of range.");
	_hlp("  Note that <index> is zero based.");
	_syn("$%lst_find[<item>,<string-list>]");
	_hlp("  Returns the zero-based index of the <item> in the <string-list>");
	_hlp("  or $_null if the <item> can not be found");
	_debug_leavetrace("doHelpOnLst");
}
//============ doHelpOnStr ============//
void KviHelp::doHelpOnStr(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnStr");
	_cmd("$%str_* FAMILY FUNCTIONS");
	_hlp("The $%str_* functions return informations about strings.");
	_des;
	_syn("$%str_equal[<string1>,<string2>]");
	_hlp("  Compares two strings ignoring case.Returns $_true if the strings are equal.");
	_syn("$%str_nequal[<string1>,<string2>]");
	_hlp("  Same as above but returns $_false if the string are equal.");
	_syn("$%str_length[<string>]");
	_hlp("  Returns the length of the string.");
	_syn("$%str_upper[<string>]");
	_syn("$%str_lower[<string>]");
	_hlp("  Transform string to upper or lower case.");
	_syn("$%str_isin[<substring>,<string>]");
	_hlp("  Returns true if <substring> is found in <string>");
	_syn("$%str_find[<substring>,<string>]");
	_hlp("  Returns the index (zero based) of the first <substring>");
	_hlp("  found in string. Returns $_null if the <substring> is not found.");
	_syn("$%str_left[<length>,<string>]");
	_syn("$%str_right[<length>,<string>]");
	_hlp("  Returns a substring of <string> formed by the <length> characters");
	_hlp("  of the left (or right) part of the string.");
	_debug_leavetrace("doHelpOnStr");
}
//============ doHelpOnIs ============//
void KviHelp::doHelpOnIs(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnIs");
	_cmd("$%wnd_* FAMILY FUNCTIONS");
	_hlp("The $%wnd_* functions will return informations on the window names.");
	_syn("$%wnd_functionname[<window name>]");
	_des;
	_hlp("$%wnd_ischan   : Returns $_true if <window> is a channel window");
	_hlp("                 $_false otherwise.");
	_hlp("$%wnd_ischat   : Returns $_true if <window> is a DCC Chat window.");
	_hlp("$%wnd_isquery  : Same as above but for query windows.");
	_hlp("$%wnd_issend   : Same as above but for DCC SEND/GET windows.");
	_hlp("$%wnd_isstatus : Same as above but for the Status window.");
	_hlp("$%wnd_isuserwnd: Same as above but for User created windows.");
	_hlp("Note that all these functions will return $_null if the window can not be found.");
	_debug_leavetrace("doHelpOnIs");
}
//============ doHelpOnCh ============//
void KviHelp::doHelpOnChn(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnCh");
	_cmd("$%chn_* FAMILY FUNCTIONS");
	_hlp("The $%chn_* functions will return informations on a channel.");
	_syn("$%chn_functionname[<channel>]");
	_des;
	_hlp("$%chn_opcount    : Returns the number of operators on the channel.");
	_hlp("$%chn_voicecount : Returns the number of voiced users on the channel.");
	_hlp("$%chn_count      : Returns the total number of users on the channel.");
	_hlp("$%chn_nopcount   : Returns the number of non-operators on the channel.");
	_hlp("$%chn_allonchan  : Returns a list of nicknames that are on the channel.");
	_hlp("$%chn_oponchan   : Returns a list of operators that are on the channel.");
	_hlp("$%chn_voicechan  : Returns a list of voiced users...");
	_hlp("$%chn_noponchan  : Returns a list of non-operators...");
	_hlp("$%chn_topic      : Returns the current channel topic");
	_hlp("$%chn_mode       : Returns a string containing the current channel mode.");

	_hlp("Note : the functions returning a list of strings are limited to 300 characters.");
	_hlp("All the functions will return $_null if you are NOT on the channel specified.");
	_debug_leavetrace("doHelpOnCh");
}
//============ doHelpOnNk ============//
void KviHelp::doHelpOnNk(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnNk");
	_cmd("$%nck_* FAMILY FUNCTIONS AND RELATED");
	_hlp("The $%nck_* functions will return informations on a user that is on a specified channel.");
	_syn("$%nck_functionname[<channel>,<nick>]");
	_syn("Special case : $%nck_isme[<nickname or mask>]");
	_des;
	_hlp("$%nck_address    : Returns the nick address that is stored in the INTERNAL ADDRESS LIST");
	_hlp("                   Note that if the list is not complete (or not enabled) the result will");
	_hlp("                   be $_null.");
	_hlp("$%nck_ison       : Returns $_true if the nick is on the channel.");
	_hlp("$%nck_isop       : Returns $_true if the nick is an operator on the channel.");
	_hlp("$%nck_isvoice    : Returns $_true if the nick have the +v flag.");
	_hlp("$%nck_maskX      : Return the mask (of type X) of the nick.");
	_hlp("                   Currently masks from 0 to 8 are allowed.");
	_hlp("mask types:");
	_hlp("0  : Nick!User@host.domain.top");
	_hlp("1  : User@host.domain.top");
	_hlp("2  : Nick!*@host.domain.top");
	_hlp("3  : *!User@host.domain.top");
	_hlp("4  : Nick!*@*");
	_hlp("5  : *!*@*.domain.top       (or *!*@xxx.xxx.xxx.*)");
	_hlp("6  : *!User@*.domain.top    (or *!User@xxx.xxx.xxx.*)");
	_hlp("7  : Nick!User@*.domain.top (or Nick!User@xxx.xxx.xxx.*)");
	_hlp("8  : Nick!*@*.domain.top    (or Nick!*@xxx.xxx.xxx.*)");
	_exa("if ($%nck_ison[#kaos,turk187]) ban $%nck_mask7[#kaos,turk187]");
	_hlp("Note1 : the nck_isop and nk_isvoice functions will return $_null if the nick");
	_hlp("        is NOT on the channel.");
	_hlp("Note2 : the nck_maskX,like nck_address, uses the Internal Address List,");
	_hlp("        If the list is not complete for the channel requested, the result may be");
	_hlp("        something as Nick!$_null@$_null...");
	_hlp("        Note also that if a user is on two channels and in the second one the user list");
	_hlp("        is not complete, nck_maskX on the first channel will return the full mask");
	_hlp("        and on the second channel will return some $_null strings..");
	_hlp("$%nck_isme : Evaluates to true if the nick is your current nick");
	_hlp("          or the mask matches your mask.");
	_debug_leavetrace("doHelpOnNk");
}
//============ doHelpOnBox ============//
void KviHelp::doHelpOnBox(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnBox");
	_cmd("$%box_* FAMILY FUNCTIONS");
	_hlp("The $%box_* functions can make your scripts more interactive.");
	_hlp("Every function of this family will show/ask user something");
	_hlp("and then return you the result."); 
	_des;
	_hlp("$%box_yesno[<message text>]   : Shows a 'question' message-box.The user can answer");
	_hlp("                                'yes' or 'not'.If the user selects 'yes' the function");
	_hlp("                                will return $_true , $_false otherwise.");
	_hlp("$%box_input[<message text>]   : Shows an 'input' box, where the user can insert some text.");
	_hlp("                                The function will return the text if the user selects 'Ok'");
	_hlp("                                or $_null if the user selects 'Cancel'");
	_hlp("$%box_openfile[<initial dir>] : Asks user for a file to open.");
	_hlp("                                The function will return an absolute path to a file if the");
	_hlp("                                selects an EXISTING file , $_null otherwise");
	_hlp("                                Pass $_null as initial dir if you dont need to preset it.");
	_hlp("$%box_savefile[<preset file>] : Asks user for a file name to save.");
	_hlp("                                The function will return an absolute path to a file or");
	_hlp("                                $_null if the user selects 'Cancel'");
	_hlp("                                Pass $_null as parameter if you don't need a preset filename.");
	_exa("if ($%box_yesno[Do you like KVirc ?]) echo $_window Great! :);else echo $_window :((((");  
	_debug_leavetrace("doHelpOnBox");
}
//============ doHelpOnVariables ============//
void KviHelp::doHelpOnVariables(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnVariables");
	_cmd("VARIABLES");
	_hlp("KVIrc allows you to set and unset variables.");
	_hlp("A variable identifier MUST start with a '$'.");
	_hlp("The variables are always evaluated before executing a command");
	_hlp("or sending text to server.");
	_exa("/SET $string Some funny text;ECHO $_window $string")
	_hlp("The example above will produce an output in the current window.");
	_hlp("You can also write text on channel using variables,");
	_exa("/SET $string Gray");
	_exa("Type in a channel : My shirt is $string");
	_hlp("The example above will send to the channel : My shirt is Gray");
	_hlp("KVIrc has a number of internal variables that you can use.");
	_hlp("The internal variables always begin with a '$_'.");
	_hlp("INTERNAL VARIABLES LIST (type /help <variable-name>)");
	_hlp("$_chan       $_window     $_mynick   $_myserver   $_myport");
	_hlp("$_myusername $_myrealname $_myip     $_myserverip $_mynetwork");
	_hlp("$_mymask     $_version    $_status   $_false      $_true");
	_hlp("$_null       $_date       $_time     $_allchans   $_$");
	_hlp("$_[          $_]          $_:        $_K          $_R");
	_hlp("$0           $_O          $_U        $_B          $_myaddress");
	_hlp("$_selected   $_target     $_allchats $_allqueries $_allchattargets");
	_hlp("$_dirhome    $_dirkvirc");
	_hlp("Variables allow you to insert 'variable' commands in your scripts");
	_exa("/set $cmd echo; $cmd $_window Ciao");
	_hlp("The example above will 'echo' the string Ciao to the current window.");
	_see("SET UNSET ECHO");
	_debug_leavetrace("doHelpOnVariables");
}
//============ doHelpOnDir ============//
void KviHelp::doHelpOnDir(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnDir");
	_cmd("$_dir* FAMILY VARIABLES");
	_hlp("The $_dir* variabled contain directory names");
	_des;
	_hlp("$_dirhome  : Returns your home directory path");
	_hlp("$_dirkvirc : Returns your kvirc directory path.(Usually equal to $HOME/kvirc");
	_debug_leavetrace("doHelpOnDir");
}
//============ doHelpOnMy ============//
void KviHelp::doHelpOnMy(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnMy");
	_cmd("$_my* FAMILY VARIABLES");
	_hlp("The $_my* variables contain informations about you.");
	_hlp("When you are not connected, they will always evaluate to $_null");
	_des;
	_hlp("$_mynick     : Contains your current nick.");
	_hlp("$_myserver   : Contains your current server name.");
	_hlp("$_myserverip : Contains your current server IP address.");
	_hlp("$_myport     : Contains the port number that you're connected to.");
	_hlp("$_myusername : Contains your current username.");
	_hlp("$_myrealname : Contains your current real name.");
	_hlp("$_myip       : Contains your IP address.");
	_hlp("$_mynetwork  : Contains the name of the network that you ae connected to.");
	_hlp("$_myaddress  : Contains your address ah the server knows it.");
	_hlp("$_mymask     : Contains your extended mask.");
	_debug_leavetrace("doHelpOnMy");
}
//============ doHelpOnCh ============//
void KviHelp::doHelpOnCh(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnCh");
	_cmd("WINDOW RELATED VARIABLES");
	_hlp("$_chan $_window $_status $_allchans");
	_des;
	_hlp("$_window     : Contains the current window name.");
	_hlp("               (i.e. the window from where the command is executed).");
	_hlp("$_chan       : Contains the current channel name.");
	_hlp("               (like $_window but evaluates to $_null if");
	_hlp("                the current window is not a channel");
	_hlp("$_status     : Contains the status console name.");
	_hlp("               Useful for the ECHO command");
	_hlp("$_allchans   : Contains the comma separated list of all channels");
	_hlp("               that you are on.(or $_null)");
	_hlp("$_allchats   : Same as above but for chat window names");
	_hlp("$_allqueries : Same as above but for query windows.");
	_hlp("$_allchattargets : Same as above but for the DCC chat remote nicks.");
	_hlp("$_target     : Contains the remote end name of the window.");
	_hlp("               On a channel is equivalent to $_chan");
	_hlp("               On a query or chat window contains the remote nick.");
	_hlp("$_selected   : Contains the selection for the current channel");
	_hlp("               $_selected should be used ONLY from channel popups.");
	_exa("ECHO $_status I execute this command from $_window;IF (! $_chan) ECHO $_window You're not on a channel;");
	_debug_leavetrace("doHelpOnCh");
}

//============ doHelpOnFl ============//

void KviHelp::doHelpOnFl(KviMdiChild *lpC)
{
	_debug_entertrace("doHelpOnFl");
	_cmd("CONTROL VARIABLES");
	_hlp("$_false $_true $_null");
	_des;
	_hlp("These three variables are useful only for scripting.");
	_hlp("In fact are particular STRINGS.(see below)");
	_exa("IF ( $_null ) echo $_status You will newer see this message;");
	_hlp(KVI_STR_FALSE);
	_hlp(KVI_STR_NULL);
	_hlp(KVI_STR_TRUE);
	_see("IF VARIABLES");
	_debug_leavetrace("doHelpOnFl");
}
