//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this program; see the file COPYING.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_LISTBOX_H_INCLUDED_
#define _KVI_LISTBOX_H_INCLUDED_

class KviListBox : public QListBox{
	Q_OBJECT
public:
	KviListBox(QWidget *parent,KviMdiChild *lpParent,KviFrame *lpFrame,const char *name=0);
	~KviListBox();
public:
	KviMdiChild *m_lpParent;
	KviFrame *m_lpMainFrame;
	KviInterface *m_lpInt;
	QList<KviNick> *m_lpNickList;
	QPixmap *m_lpMemBuffer;
	QFontMetrics *m_lpfM;
public:
	void nickJoin(KviNick &kvNick);
	void nickJoin(QString &szNick);
	void nickJoin(const char *szNick);

	void nickPart(KviNick &kvNick);
	void nickPart(QString &szNick);
	void nickPart(const char *szNick);

	int findNick(KviNick &kvNick);
	int findNick(QString &szNick);
	int findNick(const char *szNick);
	void removeAll();
	void insertNick(KviNick &kvNick);
protected :
	virtual void paintCell(QPainter *p,int row,int col);
	virtual void paintEvent(QPaintEvent *);
	virtual void mousePressEvent(QMouseEvent *e);
	virtual void mouseDoubleClickEvent(QMouseEvent *e);
	virtual void resizeEvent(QResizeEvent *e);
};

#endif //_KVI_LISTBOX_H_INCLUDED_
