//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_SEND_H_INCLUDED_
#define _KVI_SEND_H_INCLUDED_

class KviSendWnd : public KviMdiChild
{
	Q_OBJECT
public:	
	KviSendWnd(KviMdiManager *parent,KviFrame *frame,const char *aname,int aid);
	~KviSendWnd();

//	KviView			*m_lpOutput;
	KProgress		*m_lpProgress;

	QString m_szFileName;
	QFile	*m_lpFile;
	QString m_szRemoteNick;
	KviListeningSocket	*m_lpListeningSocket;
	int m_Sock;
	QSocketNotifier *m_lpReadNotifier;
	QSocketNotifier *m_lpWriteNotifier;
	QLabel			*m_lpLabel;
	QString         m_szPort;
	struct in_addr  m_inAddress;
	time_t			m_startTime;
	uint			m_iNumAck;
	QTimer			*m_lpTimer;
	unsigned short int m_iPort;
	bool m_bSending;
	bool m_bConnected;
	uint m_iFileLength;
	uint m_iFileSent;
	uint m_iFileRead;
public:
	void applyOptions();
	void doFmtOutput(int nType,const char *szFmt,...);
	void doOutput(int nType,const char *szText);
	void sendFileBuffer();
	void killSock();
	void destroyFile();
	void initiateResumeGet();
	void destroyTimer();
	void destroyReadNotifier();
	void destroyWriteNotifier();
	void destroyListeningSocket();
	bool dccResumeForCurrentSend(uint iPosition);
	void setLabelInfo(uint iBytesLeft,uint iBytesRight);
	bool requestSend(const char *szNick,const char *szFileName);
	bool acceptSend(const char *szNick,QString &szPort,QString &szIp,const char *szFileName,QString szSize,bool bResume=false);
	void terminateByError(const char *szType,const char *szErr);
	void terminateBySuccess(const char *szType);
protected:
	virtual void resizeEvent(QResizeEvent *);
protected slots:
	void closeSlot();
	void connectedSlot();
	void slotConnected(int);
	void connectTimedOut();
	void slotDataInBuffer(int);
};


#endif // _KVI_STATUS_H_INCLUDED_
