//
//   This file is part of the KVIrc+ irc client distribution
//   Copyright (C) 1998 Szymon Stefanek (stefanek@tin.it)
//
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the GNU Library General Public
//   License as published by the Free Software Foundation; either
//   version 2 of the License, or (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//   Library General Public License for more details.
//
//   You should have received a copy of the GNU Library General Public License
//   along with this library; see the file COPYING.LIB.  If not, write to
//   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
//   Boston, MA 02111-1307, USA.
//
#ifndef _KVI_TASKBAR_H_INCLUDED_
#define _KVI_TASKBAR_H_INCLUDED_


class KviTaskBar : public KToolBar
{
	Q_OBJECT
public:
	KviTaskBar(KTopLevelWidget *lpFrame,KviMdiManager *lpMdiManager,const char *name=0);
	~KviTaskBar();
protected:
	KTopLevelWidget         *m_lpFrm;
	KviMdiManager           *m_lpMdi;
	QButtonGroup            *m_lpButtonGroup;
	QList<KviTaskBarButton> *m_lpBtnList;
	int                      m_iLastHeight;
public:
	KviTaskBarButton * addButton(int nID,const char *text,const char *szIconName,bool bNeedProgress=false);
	void changeButtonText(int nID,const char *text);
	void removeButton(int m_nID);
	void setActiveButton(int nID);
	void highlightButton(int nID);
	void setButtonProgress(int nID,int iProgress);
	void unpressAllButtons();
signals:
	void itemActivated(int nId);
	void taskBarPopupRequest(QPoint glPoint,int nId);
public slots:
	KviTaskBarButton * findButton(int nID);
	void slotButtonPressed(int nId);
protected:
	void layoutButtons();
	bool eventFilter ( QObject *ob, QEvent *e );
	virtual void resizeEvent(QResizeEvent *);
	virtual void focusInEvent(QFocusEvent *);
};



#endif // _KVI_TASKBAR_H_INCLUDED_
